Index: code/branches/physics/src/orxonox/objects/collisionshapes/CollisionShape.cc
===================================================================
--- code/branches/physics/src/orxonox/objects/collisionshapes/CollisionShape.cc	(revision 2431)
+++ code/branches/physics/src/orxonox/objects/collisionshapes/CollisionShape.cc	(revision 2433)
@@ -100,12 +100,10 @@
     void CollisionShape::setScale3D(const Vector3& scale)
     {
-        ThrowException(NotImplemented, "Cannot set the scale of a collision shape: Not yet implemented.");
-        this->updateParent();
+        CCOUT(2) << "Warning: Cannot set the scale of a collision shape: Not yet implemented." << std::endl;
     }
 
     void CollisionShape::setScale(float scale)
     {
-        ThrowException(NotImplemented, "Cannot set the scale of a collision shape: Not yet implemented.");
-        this->updateParent();
+        CCOUT(2) << "Warning: Cannot set the scale of a collision shape: Not yet implemented." << std::endl;
     }
 
Index: code/branches/physics/src/orxonox/objects/collisionshapes/CompoundCollisionShape.cc
===================================================================
--- code/branches/physics/src/orxonox/objects/collisionshapes/CompoundCollisionShape.cc	(revision 2431)
+++ code/branches/physics/src/orxonox/objects/collisionshapes/CompoundCollisionShape.cc	(revision 2433)
@@ -72,5 +72,5 @@
         if (this->childShapes_.find(shape) != this->childShapes_.end())
         {
-            ThrowException(NotImplemented, "Warning: Attaching a CollisionShape twice is not yet supported.");
+            CCOUT(2) << "Warning: Attaching a CollisionShape twice is not yet supported." << std::endl;
             return;
         }
Index: code/branches/physics/src/orxonox/objects/worldentities/StaticEntity.cc
===================================================================
--- code/branches/physics/src/orxonox/objects/worldentities/StaticEntity.cc	(revision 2431)
+++ code/branches/physics/src/orxonox/objects/worldentities/StaticEntity.cc	(revision 2433)
@@ -62,5 +62,8 @@
     {
         if (this->addedToPhysicalWorld())
-            ThrowException(PhysicsViolation, "Cannot change position or orientation of a StaticEntity with physics at run time.");
+        {
+            CCOUT(2) << "Warning: Attempting to change the position of a StaticEntity at physics run time. Ignoring change." << std::endl;
+            return;
+        }
         if (this->isStatic())
         {
@@ -76,5 +79,8 @@
     {
         if (this->addedToPhysicalWorld())
-            ThrowException(PhysicsViolation, "Cannot change position or orientation of a StaticEntity with physics at run time.");
+        {
+            CCOUT(2) << "Warning: Attempting to change the orientation of a StaticEntity at physics run time. Ignoring change." << std::endl;
+            return;
+        }
         if (this->isStatic())
         {
@@ -101,5 +107,4 @@
     {
         OrxAssert(false, "Setting world transform of a StaticEntity, which is CF_STATIC!");
-        //COUT(0) << "Setting world transform of a StaticEntity, which is static!" << std::endl;
     }
 
Index: code/branches/physics/src/orxonox/objects/worldentities/WorldEntity.cc
===================================================================
--- code/branches/physics/src/orxonox/objects/worldentities/WorldEntity.cc	(revision 2431)
+++ code/branches/physics/src/orxonox/objects/worldentities/WorldEntity.cc	(revision 2433)
@@ -194,11 +194,23 @@
         {
             if (!this->hasPhysics())
-                ThrowException(PhysicsViolation, "Cannot attach a physical object to a non physical one.");
+            {
+                COUT(2) << "Warning: Cannot attach a physical object to a non physical one." << std::endl;
+                return;
+            }
             else if (object->isDynamic())
-                ThrowException(PhysicsViolation, "Cannot attach a dynamic object to a WorldEntity.");
+            {
+                COUT(2) << "Warning: Cannot attach a dynamic object to a WorldEntity." << std::endl;
+                return;
+            }
             else if (object->isKinematic() && this->isDynamic())
-                ThrowException(PhysicsViolation, "Cannot attach a kinematic object to a dynamic one.");
+            {
+                COUT(2) << "Warning: Cannot attach a kinematic object to a dynamic one." << std::endl;
+                return;
+            }
             else if (object->isKinematic())
-                ThrowException(NotImplemented, "Cannot attach a kinematic object to a static or kinematic one: Not yet implemented.");
+            {
+                COUT(2) << "Warning: Cannot attach a kinematic object to a static or kinematic one: Not yet implemented." << std::endl;
+                return;
+            }
             else
             {
@@ -424,5 +436,8 @@
     {
         if (this->hasPhysics())
-            ThrowException(NotImplemented, "Cannot set the scale of a physical object: Not yet implemented.");
+        {
+            CCOUT(2) << "Warning: Cannot set the scale of a physical object: Not yet implemented." << std::endl;
+            return;
+        }
 
         this->node_->setScale(scale);
@@ -433,7 +448,13 @@
         // If we are already attached to a parent, this would be a bad idea..
         if (this->parent_)
-            ThrowException(PhysicsViolation, "Cannot set the collision type of a WorldEntity with a parent");
+        {
+            CCOUT(2) << "Warning: Cannot set the collision type of a WorldEntity with a parent." << std::endl;
+            return;
+        }
         else if (this->addedToPhysicalWorld())
-            ThrowException(PhysicsViolation, "Cannot set the collision type at run time.");
+        {
+            CCOUT(2) << "Warning: Cannot set the collision type at run time." << std::endl;
+            return;
+        }
 
         // Check for type legality. Could be StaticEntity or MobileEntity
@@ -441,5 +462,8 @@
             return; // exception gets issued anyway
         if (type != None && !this->getScene()->hasPhysics())
-            ThrowException(PhysicsViolation, "Cannot have physical bodies in a non physical scene");
+        {
+            CCOUT(2) << "Warning: Cannot have physical bodies in a non physical scene." << std::endl;
+            return;
+        }
 
         // Check whether we have to create or destroy.
@@ -448,5 +472,8 @@
             // Check whether there was some scaling applied.
             if (!this->node_->getScale().positionEquals(Vector3(1, 1, 1), 0.001))
-                ThrowException(NotImplemented, "Cannot create a physical body if there is scaling applied to the node: Not yet implemented.");
+            {
+                CCOUT(2) << "Warning: Cannot create a physical body if there is scaling applied to the node: Not yet implemented." << std::endl;
+                return;
+            }
 
             // Create new rigid body