Index: code/branches/presentation/src/orxonox/objects/quest/AddQuest.cc
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/AddQuest.cc	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/AddQuest.cc	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file AddQuest.cc
+    @file
     @brief Implementation of the AddQuest class.
 */
@@ -44,6 +44,6 @@
 #include "Quest.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     CreateFactory(AddQuest);
 
Index: code/branches/presentation/src/orxonox/objects/quest/AddQuest.h
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/AddQuest.h	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/AddQuest.h	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file AddQuest.h
+    @file
     @brief Definition of the AddQuest class.
 */
@@ -42,6 +42,6 @@
 #include "ChangeQuestStatus.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
Index: code/branches/presentation/src/orxonox/objects/quest/AddQuestHint.cc
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/AddQuestHint.cc	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/AddQuestHint.cc	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file AddQuestHint.cc
+    @file
     @brief Implementation of the AddQuestHint class.
 */
@@ -43,6 +43,6 @@
 #include "QuestHint.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     CreateFactory(AddQuestHint);
 
Index: code/branches/presentation/src/orxonox/objects/quest/AddQuestHint.h
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/AddQuestHint.h	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/AddQuestHint.h	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file AddQuestHint.h
+    @file
     @brief Definition of the AddQuestHint class.
 */
@@ -41,6 +41,6 @@
 #include "QuestEffect.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
Index: code/branches/presentation/src/orxonox/objects/quest/AddReward.cc
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/AddReward.cc	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/AddReward.cc	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file AddReward.cc
+    @file
     @brief Implementation of the AddReward class.
 */
@@ -40,6 +40,6 @@
 #include "Rewardable.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     CreateFactory(AddReward);
 
Index: code/branches/presentation/src/orxonox/objects/quest/AddReward.h
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/AddReward.h	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/AddReward.h	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file AddReward.h
+    @file
     @brief Definition of the AddReward class.
 */
@@ -42,6 +42,6 @@
 #include "QuestEffect.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
Index: code/branches/presentation/src/orxonox/objects/quest/ChangeQuestStatus.cc
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/ChangeQuestStatus.cc	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/ChangeQuestStatus.cc	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file ChangeQuestStatus.cc
+    @file
     @brief Implementation of the ChangeQuestStatus class.
 */
@@ -39,6 +39,6 @@
 #include "QuestItem.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
Index: code/branches/presentation/src/orxonox/objects/quest/ChangeQuestStatus.h
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/ChangeQuestStatus.h	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/ChangeQuestStatus.h	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file ChangeQuestStatus.h
+    @file
     @brief Definition of the ChangeQuestStatus class.
 */
@@ -42,6 +42,6 @@
 #include "QuestEffect.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
Index: code/branches/presentation/src/orxonox/objects/quest/CompleteQuest.cc
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/CompleteQuest.cc	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/CompleteQuest.cc	(revision 2435)
@@ -28,5 +28,5 @@
  
 /**
-    @file CompleteQuest.cc
+    @file
     @brief Implementation of the CompleteQuest class.
 */
@@ -42,6 +42,6 @@
 #include "Quest.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     CreateFactory(CompleteQuest);
 
Index: code/branches/presentation/src/orxonox/objects/quest/CompleteQuest.h
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/CompleteQuest.h	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/CompleteQuest.h	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file CompleteQuest.h
+    @file
     @brief Definition of the CompleteQuest class.
 */
@@ -42,6 +42,6 @@
 #include "ChangeQuestStatus.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
Index: code/branches/presentation/src/orxonox/objects/quest/FailQuest.cc
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/FailQuest.cc	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/FailQuest.cc	(revision 2435)
@@ -28,5 +28,5 @@
  
 /**
-    @file FailQuest.cc
+    @file
     @brief Implementation of the FailQuest class.
 */
@@ -42,6 +42,6 @@
 #include "Quest.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     CreateFactory(FailQuest);
 
Index: code/branches/presentation/src/orxonox/objects/quest/FailQuest.h
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/FailQuest.h	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/FailQuest.h	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file FailQuest.h
+    @file
     @brief Definition of the FailQuest class.
 */
@@ -42,6 +42,6 @@
 #include "ChangeQuestStatus.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
Index: code/branches/presentation/src/orxonox/objects/quest/GlobalQuest.cc
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/GlobalQuest.cc	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/GlobalQuest.cc	(revision 2435)
@@ -28,5 +28,5 @@
  
 /**
-    @file GlobalQuest.cc
+    @file
     @brief Implementation of the GlobalQuest class.
 */
@@ -42,6 +42,6 @@
 #include "QuestEffect.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     CreateFactory(GlobalQuest);
 
Index: code/branches/presentation/src/orxonox/objects/quest/GlobalQuest.h
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/GlobalQuest.h	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/GlobalQuest.h	(revision 2435)
@@ -28,5 +28,5 @@
  
 /**
-    @file GlobalQuest.h
+    @file
     @brief Definition of the GlobalQuest class.
 */
@@ -43,6 +43,6 @@
 #include "Quest.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
Index: code/branches/presentation/src/orxonox/objects/quest/LocalQuest.cc
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/LocalQuest.cc	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/LocalQuest.cc	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file LocalQuest.cc
+    @file
     @brief Implementation of the LocalQuest class.
 */
@@ -42,6 +42,6 @@
 #include "QuestEffect.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     CreateFactory(LocalQuest);
 
Index: code/branches/presentation/src/orxonox/objects/quest/LocalQuest.h
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/LocalQuest.h	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/LocalQuest.h	(revision 2435)
@@ -28,5 +28,5 @@
  
 /**
-    @file LocalQuest.h
+    @file
     @brief Definition of the LocalQuest class.
 */
@@ -43,6 +43,6 @@
 #include "Quest.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
Index: code/branches/presentation/src/orxonox/objects/quest/Quest.cc
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/Quest.cc	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/Quest.cc	(revision 2435)
@@ -28,5 +28,5 @@
  
 /**
-    @file Quest.cc
+    @file
     @brief Implementation of the Quest class.
 */
@@ -44,6 +44,6 @@
 #include "QuestListener.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
Index: code/branches/presentation/src/orxonox/objects/quest/Quest.h
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/Quest.h	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/Quest.h	(revision 2435)
@@ -28,5 +28,5 @@
  
 /**
-    @file Quest.h
+    @file
     @brief Definition of the Quest class.
         The Quest is the parent class of LocalQuest and GlobalQuest.
@@ -45,19 +45,19 @@
 #include "QuestItem.h"
 
-namespace questStatus
+namespace orxonox
 {
+    namespace questStatus
+    {
 
-    //!Different states of a Quest.
-    enum Enum
-    {
-        inactive,
-        active,
-        failed,
-        completed
-    };
+        //!Different states of a Quest.
+        enum Enum
+        {
+            inactive,
+            active,
+            failed,
+            completed
+        };
 
-}
-
-namespace orxonox {
+    }
 
     /**
Index: code/branches/presentation/src/orxonox/objects/quest/QuestDescription.cc
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/QuestDescription.cc	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/QuestDescription.cc	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file QuestDescription.cc
+    @file
     @brief Implementation of the QuestDescription class.
 */
@@ -39,6 +39,6 @@
 #include "orxonox/overlays/notifications/Notification.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     CreateFactory(QuestDescription);
 
@@ -128,5 +128,5 @@
         }
         
-        Notification* notification = new Notification(message, title, 30);
+        Notification* notification = new Notification(0, message, title, 30);
         notification->send();
         return true;
Index: code/branches/presentation/src/orxonox/objects/quest/QuestDescription.h
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/QuestDescription.h	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/QuestDescription.h	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file QuestDescription.h
+    @file
     @brief Definition of the QuestDescription class.
 */
@@ -42,6 +42,6 @@
 #include "core/XMLPort.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
@@ -55,6 +55,6 @@
         Damian 'Mozork' Frick
     */
-    class _OrxonoxExport QuestDescription : public BaseObject {
-
+    class _OrxonoxExport QuestDescription : public BaseObject
+    {
         public:
             QuestDescription(BaseObject* creator);
Index: code/branches/presentation/src/orxonox/objects/quest/QuestEffect.cc
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/QuestEffect.cc	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/QuestEffect.cc	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file QuestEffect.cc
+    @file
     @brief Implementation of the QuestEffect class.
 */
@@ -39,6 +39,6 @@
 #include "orxonox/objects/infos/PlayerInfo.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
Index: code/branches/presentation/src/orxonox/objects/quest/QuestEffect.h
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/QuestEffect.h	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/QuestEffect.h	(revision 2435)
@@ -28,5 +28,5 @@
  
 /**
-    @file QuestEffect.h
+    @file
     @brief Definition of the QuestEffect class.
 */
@@ -41,6 +41,6 @@
 #include "core/BaseObject.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
Index: code/branches/presentation/src/orxonox/objects/quest/QuestEffectBeacon.cc
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/QuestEffectBeacon.cc	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/QuestEffectBeacon.cc	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file QuestEffectBeacon.cc
+    @file
     @brief Implementation of the QuestEffectBeacon class.
 */
@@ -45,6 +45,6 @@
 #include "QuestEffect.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     CreateFactory(QuestEffectBeacon);
 
@@ -58,5 +58,5 @@
         
         this->status_ = QuestEffectBeaconStatus::active;
-        this->times_ = INFINITE;
+        this->times_ = INFINITE_TIME;
     }
 
@@ -186,5 +186,5 @@
             return false;
         }
-        if(this->getTimes() == INFINITE) //!< If times is infinity the QuestEffectBeacon can be executed an infinite number fo times.
+        if(this->getTimes() == INFINITE_TIME) //!< If times is infinity the QuestEffectBeacon can be executed an infinite number fo times.
         {
             return true;
@@ -212,5 +212,5 @@
     bool QuestEffectBeacon::setTimes(const int & n)
     {
-        if(n < 0 && n != INFINITE)
+        if(n < 0 && n != INFINITE_TIME)
         {
             return false;
Index: code/branches/presentation/src/orxonox/objects/quest/QuestEffectBeacon.h
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/QuestEffectBeacon.h	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/QuestEffectBeacon.h	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file QuestEffectBeacon.h
+    @file
     @brief Definition of the QuestEffectBeacon class.
 */
@@ -39,17 +39,17 @@
 #include "orxonox/objects/worldentities/PositionableEntity.h"
 
-namespace QuestEffectBeaconStatus
+namespace orxonox
 {
+    namespace QuestEffectBeaconStatus
+    {
 
-    //! The status of the beacon, can be either active or inactive.
-    enum Enum
-    {
-        inactive,
-        active
-    };
+        //! The status of the beacon, can be either active or inactive.
+        enum Enum
+        {
+            inactive,
+            active
+        };
 
-}
-
-namespace orxonox {
+    }
 
     /**
@@ -112,5 +112,5 @@
     
         private:
-            static const int INFINITE = -1; //!< Constant to avoid using magic numbers.
+            static const int INFINITE_TIME = -1; //!< Constant to avoid using magic numbers.
             
             std::list<QuestEffect*> effects_; //!< The list of QuestEffects to be invoked on the executing player.
Index: code/branches/presentation/src/orxonox/objects/quest/QuestHint.cc
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/QuestHint.cc	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/QuestHint.cc	(revision 2435)
@@ -28,5 +28,5 @@
  
 /**
-    @file QuestHint.cc
+    @file
     @brief Implementation of the QuestHint class.
 */
@@ -43,6 +43,6 @@
 #include "Quest.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     CreateFactory(QuestHint);
 
Index: code/branches/presentation/src/orxonox/objects/quest/QuestHint.h
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/QuestHint.h	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/QuestHint.h	(revision 2435)
@@ -28,5 +28,5 @@
  
 /**
-    @file QuestHint.h
+    @file
     @brief Definition of the QuestHint class.
 */
@@ -43,18 +43,17 @@
 #include "QuestItem.h"
 
-namespace questHintStatus
-{
-
-    //! The state of the hint.
-    enum Enum
-    {
-        inactive,
-        active
-    };
-
-}
-
 namespace orxonox
 {
+    namespace questHintStatus
+    {
+
+        //! The state of the hint.
+        enum Enum
+        {
+            inactive,
+            active
+        };
+
+    }
 
     /**
Index: code/branches/presentation/src/orxonox/objects/quest/QuestItem.cc
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/QuestItem.cc	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/QuestItem.cc	(revision 2435)
@@ -28,5 +28,5 @@
  
 /**
-    @file QuestItem.cc
+    @file
     @brief Implementation of the QuestItem class.
 */
@@ -39,6 +39,6 @@
 #include "QuestDescription.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
Index: code/branches/presentation/src/orxonox/objects/quest/QuestItem.h
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/QuestItem.h	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/QuestItem.h	(revision 2435)
@@ -28,5 +28,5 @@
  
 /**
-    @file QuestItem.h
+    @file
     @brief Definition of the QuestItem class.
         The QuestItem is the parent class of Quest and QuestHint.
@@ -44,7 +44,6 @@
 #include "core/XMLPort.h"
 
-namespace orxonox {
-
-
+namespace orxonox
+{
     /**
     @brief
Index: code/branches/presentation/src/orxonox/objects/quest/QuestListener.cc
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/QuestListener.cc	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/QuestListener.cc	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file QuestListener.cc
+    @file
     @brief Implementation of the QuestListener class.
 */
@@ -42,6 +42,6 @@
 #include "QuestManager.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     CreateFactory(QuestListener);
 
@@ -152,6 +152,6 @@
         {
             COUT(2) << "QuestListener with invalid mode '" << mode << "' created. Mode set to 'all'." << std::endl;
-	    this->mode_ = questListenerMode::all;
-	    return false;
+        this->mode_ = questListenerMode::all;
+        return false;
         }
         
@@ -186,5 +186,5 @@
         {
             COUT(1) << "An unforseen, never to happen, Error has occured. This is impossible!" << std::endl;
-	    return "";
+        return "";
         }
     }
Index: code/branches/presentation/src/orxonox/objects/quest/QuestListener.h
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/QuestListener.h	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/QuestListener.h	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file QuestListener.h
+    @file
     @brief Definition of the QuestListener class.
 */
@@ -44,19 +44,19 @@
 #include "Quest.h"
 
-namespace questListenerMode
+namespace orxonox
 {
+    namespace questListenerMode
+    {
 
-    //! The mode of the QuestListener.
-    enum Enum
-    {
-        all,
-        start,
-        fail,
-        complete
-    };
+        //! The mode of the QuestListener.
+        enum Enum
+        {
+            all,
+            start,
+            fail,
+            complete
+        };
 
-}
-
-namespace orxonox {
+    }
 
     /**
@@ -75,33 +75,33 @@
         </BaseObject>
     @author
-	Damian 'Mozork' Frick
+    Damian 'Mozork' Frick
     */
     class _OrxonoxExport QuestListener : public BaseObject
     {
-	public:
-	    QuestListener(BaseObject* creator);
-	    virtual ~QuestListener();
-	    
-	    virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating a QuestListener object through XML.
-	    
-	    static void advertiseStatusChange(std::list<QuestListener*> & listeners, const std::string & status); //!< Makes all QuestListener in the list aware that a certain status change has occured.
-	    
-	    bool setQuestId(const std::string & id); //!< Sets the questId of the Quest the QuestListener reacts to.
-	    bool setMode(const std::string & mode); //!< Sets the mode of the QuestListener.
-	    
-	    const std::string getMode(void); //!< Get the mode of the QuestListener.
-	    
-	    /**
-	    @brief Get the questId of the Quest the QuestListener reacts to.
-	    @return Returns the questId of the Quest the QuestListener reacts to.
-	    */
-	    inline const std::string & getQuestId(void)
+    public:
+        QuestListener(BaseObject* creator);
+        virtual ~QuestListener();
+        
+        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating a QuestListener object through XML.
+        
+        static void advertiseStatusChange(std::list<QuestListener*> & listeners, const std::string & status); //!< Makes all QuestListener in the list aware that a certain status change has occured.
+        
+        bool setQuestId(const std::string & id); //!< Sets the questId of the Quest the QuestListener reacts to.
+        bool setMode(const std::string & mode); //!< Sets the mode of the QuestListener.
+        
+        const std::string getMode(void); //!< Get the mode of the QuestListener.
+        
+        /**
+        @brief Get the questId of the Quest the QuestListener reacts to.
+        @return Returns the questId of the Quest the QuestListener reacts to.
+        */
+        inline const std::string & getQuestId(void)
                 { return this->quest_->getId(); }
-	    
-	    bool execute(void); //!< Executes the QuestListener, resp. fires an Event.
-	    
-	private:
-            questListenerMode::Enum mode_; //!< The mode of the QuestListener.
-            Quest* quest_; //!< A pointer to the Quest the QuestListener is reacting to.
+        
+        bool execute(void); //!< Executes the QuestListener, resp. fires an Event.
+        
+    private:
+        questListenerMode::Enum mode_; //!< The mode of the QuestListener.
+        Quest* quest_; //!< A pointer to the Quest the QuestListener is reacting to.
     
     };
Index: code/branches/presentation/src/orxonox/objects/quest/QuestManager.cc
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/QuestManager.cc	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/QuestManager.cc	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file QuestManager.cc
+    @file
     @brief Implementation of the QuestManager class.
 */
@@ -41,6 +41,6 @@
 #include "QuestHint.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     //! All Quests registered by their id's.
     std::map<std::string, Quest*> QuestManager::questMap_s;
Index: code/branches/presentation/src/orxonox/objects/quest/QuestManager.h
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/QuestManager.h	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/QuestManager.h	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file QuestManager.h
+    @file
     @brief Definition of the QuestManager class.
 */
@@ -42,6 +42,6 @@
 #include "core/BaseObject.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
Index: code/branches/presentation/src/orxonox/objects/quest/Rewardable.cc
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/Rewardable.cc	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/Rewardable.cc	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file Rewardable.cc
+    @file
     @brief Implementation of the Rewardable class.
 */
@@ -37,6 +37,6 @@
 #include "core/CoreIncludes.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
Index: code/branches/presentation/src/orxonox/objects/quest/Rewardable.h
===================================================================
--- code/branches/presentation/src/orxonox/objects/quest/Rewardable.h	(revision 2420)
+++ code/branches/presentation/src/orxonox/objects/quest/Rewardable.h	(revision 2435)
@@ -28,5 +28,5 @@
 
 /**
-    @file Rewardable.h
+    @file
     @brief Definition of the Rewardable class.
 */
@@ -39,6 +39,6 @@
 #include "core/BaseObject.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
@@ -51,5 +51,4 @@
     class _OrxonoxExport Rewardable : public BaseObject
     {
-
         public:
             Rewardable(BaseObject* creator);